source stooop.tcl
namespace import stooop::*

### check that nested class procedure definition works inside and outside nested class or namespace

# expected output:

## 1
## 2
## 3
## 4
## 5
## 6

class a {
    class b {
        proc b {this} {}
        proc p {this} {
            puts 1
        }
    }
    set o [new b]
    b::p $o
    proc b::p {this} {
        puts 2
    }
    b::p $o
}

namespace eval c {
    class b {
        proc b {this} {}
        proc p {this} {
            puts 3
        }
    }
    set o [new b]
    b::p $o
    proc b::p {this} {
        puts 4
    }
    b::p $o
}

set o [new a::b]
proc a::b::p {this} {
    puts 5
}
a::b::p $o

set o [new c::b]
proc c::b::p {this} {
    puts 6
}
c::b::p $o
